//-----------------------------------------------------------------------------
//                                                 Mn Killing Zone v1.3.1       |
//-----------------------------------------------------------------------------

#property copyright "Mn"

#property indicator_chart_window

extern int     mHist             = 200;      //Initial history to load
extern int     mMinFirstBars     = 6;        // Number bars after big move before monitor zone
extern int     mBarsForCloseZone = 5;        // Sequence of up/down bars to signify end zone
extern double  mFact             = 2;        // Big move bar multiple of previous bar
extern double  mMinBarSize       = 3;        // Minimum size of bar before big move bar (auto set to 0 for TF <= 5m)
extern double  mBoBuffer         = 20;       // Breakout of last HL before new H:L given
extern bool    mAlert            = true;
extern bool    mShowVals         = true;
extern color   mTextCol          = Black;
extern string arrowsIdentifier    = "killing zone arrows";
extern color  arrowsUpColor       = DeepSkyBlue;
extern color  arrowsDnColor       = PaleVioletRed;

int mWidth = 1;
color mCol1 = Red, mCol2 = White, mCol3 = Aqua, mCol4 = Orange;

double mEndZone[];
static double mHval, mLval;

int mWindow, mStartBar, mStartTime, mEndBar, mEndTime, mLastStartTime;
bool NoEndZone = true, mFirstNewNotSet = true, mInitialEZ = false, mAlertNotSet = true;


//-----------------------------------------------------------------------------
void init()
 {
  mWindow = WindowFind("Gadi_OBV_v1.3");
  if(Digits == 3 || Digits == 5)
    mMinBarSize *= Point * 10;
  else
    mMinBarSize *= Point * 1;
    
  if(Period() < 6)
    mMinBarSize = 0;  
  ObjectCreate("m.ZoneStillOpen", OBJ_LABEL, 0, 0, 0, 0, 0);
  ObjectSet("m.ZoneStillOpen", OBJPROP_BACK, true);
  ObjectSet("m.ZoneStillOpen", OBJPROP_CORNER, 0);
  ObjectSet("m.ZoneStillOpen", OBJPROP_COLOR, CLR_NONE);
  ObjectSet("m.ZoneStillOpen", OBJPROP_XDISTANCE, 150);
  ObjectSet("m.ZoneStillOpen", OBJPROP_YDISTANCE, 1);
  
  for(int c = 0; c < 4; c++)
    {
      ObjectCreate("m.Val"+c, OBJ_LABEL, 0, 0, 0, 0, 0);
      ObjectSet("m.Val"+c, OBJPROP_BACK, true);
      ObjectSet("m.Val"+c, OBJPROP_CORNER, 0);
      ObjectSet("m.Val"+c, OBJPROP_COLOR, CLR_NONE);
      ObjectSet("m.Val"+c, OBJPROP_XDISTANCE, 30);
      ObjectSet("m.Val"+c, OBJPROP_YDISTANCE, 7 + 17 * c);
      ObjectSetText("m.Val"+c, "", 8, "Arial", CLR_NONE);
    }
    
     for (int i = mHist; i > mMinFirstBars; i--)        // Look for large move bar
       {
        mInitialEZ = CheckEarlyEZ(i); 
        if(MathAbs(Open[i+2] - Close[i+2]) > mMinBarSize && MathAbs(Open[i+1] - Close[i+1]) > 
            MathAbs((Open[i+2] - Close[i+2])) * mFact && !mInitialEZ)
          {
            mStartTime = Time[i];
            DrawStartZone(mStartTime);
            DrawObvLvl(mStartTime);

            while(NoEndZone && i > 0)                    // Monitor Obv and look for end zone
             {
               mStartBar = iBarShift(NULL, 0, mStartTime, true);
               mHist = mEndBar - 1;
               CheckObvLevels(mStartTime, i);
               CheckEndZone(i);
               i--;
             }
          }
       }
   return(0);
 }

//-----------------------------------------------------------------------------
void start() 
 {
  int i;
     mEndBar = iBarShift(NULL, 0, mEndTime, true);
     if(!NoEndZone && mEndBar > mMinFirstBars)
       {
        i = mMinFirstBars;
        mInitialEZ = CheckEarlyEZ(i); 
        if(MathAbs(Open[i+2] - Close[i+2]) > mMinBarSize && MathAbs(Open[i+1] - Close[i+1]) > 
            MathAbs((Open[i+2] - Close[i+2])) * mFact && !mInitialEZ && !NoEndZone)
          {
            mStartTime = Time[i];
            DrawStartZone(mStartTime);
            DrawObvLvl(mStartTime);
          }
        }
        if(NoEndZone)
          {
               mStartBar = iBarShift(NULL, 0, mStartTime, true);
               CheckObvLevels(mStartTime, i);
               CheckEndZone(i+1);
               i--;
               if(i < 0)  i = 0;
          }

  return (0);
 }

//-----------------------------------------------------------------------------
void deinit()
 {
   for(int i = ObjectsTotal(); i >= 0; i--)
     if(StringSubstr(ObjectName(i), 0, 2) == "m.")
       ObjectDelete(ObjectName(i));
   deleteArrows();
 }

//-----------------------------------------------------------------------------
void CheckObvLevels(int m1, int mCurrentBar)
 {
   static int mLastSetTime;
   static double mPrevH, mPrevL;
   double mObv = iCustom(NULL, 0, "Gadi_OBV_v1.3", 0, 0);
   double mValToAlert;
   
   if(iCustom(NULL, 0, "Gadi_OBV_v1.3", 0, mCurrentBar) < mLval)
     {
      mLval = iCustom(NULL, 0, "Gadi_OBV_v1.3", 0, mCurrentBar);
      mAlertNotSet = true;
     }
   if(iCustom(NULL, 0, "Gadi_OBV_v1.3", 0, mCurrentBar) > mHval && 
      iCustom(NULL, 0, "Gadi_OBV_v1.3", 0, mCurrentBar) < 9999999)
     {
      mHval = iCustom(NULL, 0, "Gadi_OBV_v1.3", 0, mCurrentBar);
      mAlertNotSet = true;
     }

   if(mStartBar - mCurrentBar <= mMinFirstBars)                // Draw first zone lines in OBV
     {
      ObjectSet("m.H"+m1, OBJPROP_PRICE1, mHval);
      ObjectSet("m.H"+m1, OBJPROP_PRICE2, mHval);
      ObjectSet("m.L"+m1, OBJPROP_PRICE1, mLval);
      ObjectSet("m.L"+m1, OBJPROP_PRICE2, mLval);
      mPrevH = mHval; mPrevL = mLval;
     }
      ObjectSet("m.H"+m1, OBJPROP_TIME2, Time[mCurrentBar] + Period() * 300);
      ObjectSet("m.L"+m1, OBJPROP_TIME2, Time[mCurrentBar] + Period() * 300);
   
   if(mStartBar - mCurrentBar > mMinFirstBars && mFirstNewNotSet && 
      (mHval > ObjectGet("m.H"+m1, 1) || mLval < ObjectGet("m.L"+m1, 1)))
     {
      ObjectSet("m.Hnew"+m1, OBJPROP_TIME1, Time[mCurrentBar]);
      ObjectSet("m.Lnew"+m1, OBJPROP_TIME1, Time[mCurrentBar]);
      mFirstNewNotSet = false;
     }

    if(mHval > mPrevH + mBoBuffer) 
      {
       ObjectSet("m.Hnew"+m1, OBJPROP_PRICE1, mHval);           // Move later lines in OBV for new HL
       ObjectSet("m.Hnew"+m1, OBJPROP_PRICE2, mHval);
      }
      ObjectSet("m.Hnew"+m1, OBJPROP_TIME2, Time[mCurrentBar] + Period() * 300);
    if(mLval < mPrevL - mBoBuffer)
      {
        ObjectSet("m.Lnew"+m1, OBJPROP_PRICE1, mLval);
        ObjectSet("m.Lnew"+m1, OBJPROP_PRICE2, mLval);
      }
      ObjectSet("m.Lnew"+m1, OBJPROP_TIME2, Time[mCurrentBar] + Period() * 300);

     if((mHval > mPrevH + mBoBuffer || mLval < mPrevL - mBoBuffer) && mCurrentBar < mMinFirstBars &&
         Time[0] > mLastSetTime && NoEndZone && mAlert && mAlertNotSet)
       {
        if(mHval > mPrevH + mBoBuffer)
         {
          mValToAlert = mHval;
          Alert(Symbol(), "  ", Period(), "m KZone :   ", DoubleToStr(mValToAlert, 0), " BUY ", Close[0]);
          drawArrow(mCurrentBar,arrowsUpColor,241,false);
          mPrevH = mHval;
         }
        else
         {
          mValToAlert = mLval;
          Alert(Symbol(), "  ", Period(), "m KZone :   ", DoubleToStr(mValToAlert, 0), " SELL ", Close[0]);
          drawArrow(mCurrentBar,arrowsDnColor,242,true);
          mPrevL = mLval;
         }
        mAlertNotSet = false;  
        mLastSetTime = Time[0];
       }
      
      if(mShowVals)
        {
          ObjectSetText("m.Val0", "ObvH " + DoubleToStr(mHval, 0), 8, "Arial", mTextCol);
          ObjectSetText("m.Val1", "ObvL " + DoubleToStr(mLval, 0), 8, "Arial", mTextCol);
          ObjectSetText("m.Val2", "Now  " + DoubleToStr(mObv, 0), 8, "Arial", mTextCol);
          ObjectSetText("m.Val3", "Time:  " + ((Period() * 60) - (TimeCurrent() - Time[0])), 8, "Arial", mTextCol);
        }

      
      
  return (0);
 }

void drawArrow(int mCurrentBar,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[mCurrentBar];
   double gap  = 3.0*iATR(NULL,0,20,mCurrentBar)/4.0;   
   
      //
      //SetIndexArrow
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[mCurrentBar],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[mCurrentBar]+gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[mCurrentBar] -gap);
}

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//-----------------------------------------------------------------------------
void CheckEndZone(int j)
 {
   bool mClosingBars = false, mUpClose = false, mDownClose = false;
   
   if(mStartBar - j > mMinFirstBars)   
    {
       for(int y = 0; y < mBarsForCloseZone; y++)
         if(Close[j+y] >= Open[j+y])
          mUpClose = true;
         else
          {
            mUpClose = false;
            break;
          }
       for(y = 0; y < mBarsForCloseZone; y++)
         if(Close[j+y] <= Open[j+y])
          mDownClose = true;
         else
          {
            mDownClose = false;
            break;
          }

         if(mUpClose || mDownClose)
           {
            if(ObjectFind("m.EndZoneVL"+Time[j]) < 0)
              ObjectCreate("m.EndZoneVL"+Time[j], OBJ_VLINE, 0, 0, 0, 0, 0);
            ObjectSet("m.EndZoneVL"+Time[j], OBJPROP_BACK, true);
            ObjectSet("m.EndZoneVL"+Time[j], OBJPROP_STYLE, 0);
            ObjectSet("m.EndZoneVL"+Time[j], OBJPROP_COLOR, mCol1);
            ObjectSet("m.EndZoneVL"+Time[j], OBJPROP_WIDTH, mWidth);
            ObjectSet("m.EndZoneVL"+Time[j], OBJPROP_TIME1, Time[j]);
            ObjectSet("m.EndZoneVL"+Time[j], OBJPROP_COLOR, mCol1);
            ObjectSet("m.H"+mLastStartTime, OBJPROP_TIME2, Time[j]);
            ObjectSet("m.L"+mLastStartTime, OBJPROP_TIME2, Time[j]);
            ObjectSet("m.Hnew"+mLastStartTime, OBJPROP_TIME2, Time[j]);
            ObjectSet("m.Lnew"+mLastStartTime, OBJPROP_TIME2, Time[j]);
            mEndTime = Time[j];
            mEndBar = iBarShift(NULL, 0, mEndTime, true);
            NoEndZone = false; 
            mFirstNewNotSet = true;
            ObjectSetText("m.ZoneStillOpen", "", 10, "Arial", CLR_NONE);
          }
    } // if

  return (0);
 }

//-----------------------------------------------------------------------------
void DrawStartZone(int mTime)
 {
    ObjectCreate("m.StartZoneVL"+mTime, OBJ_VLINE, 0, 0, 0, 0, 0);
    ObjectSet("m.StartZoneVL"+mTime, OBJPROP_BACK, true);
    ObjectSet("m.StartZoneVL"+mTime, OBJPROP_STYLE, 0);
    ObjectSet("m.StartZoneVL"+mTime, OBJPROP_COLOR, mCol2);
    ObjectSet("m.StartZoneVL"+mTime, OBJPROP_WIDTH, mWidth+1);
    ObjectSet("m.StartZoneVL"+mTime, OBJPROP_TIME1, mTime);
    mHval = -9999999; mLval = 9999999;
    NoEndZone = true; 
    mLastStartTime = mTime;
    ObjectSetText("m.ZoneStillOpen", CharToStr(174), 50, "WingDings", mCol2);

  return (0);
 }

//-----------------------------------------------------------------------------
void DrawObvLvl(int mObvTime)
 {
    ObjectCreate("m.H"+mObvTime, OBJ_TREND, mWindow, mObvTime, 0, mObvTime, 0);
    ObjectSet("m.H"+mObvTime, OBJPROP_BACK, true);
    ObjectSet("m.H"+mObvTime, OBJPROP_STYLE, 0);
    ObjectSet("m.H"+mObvTime, OBJPROP_COLOR, mCol3);
    ObjectSet("m.H"+mObvTime, OBJPROP_WIDTH, mWidth);
    ObjectSet("m.H"+mObvTime, OBJPROP_RAY, false);

    ObjectCreate("m.L"+mObvTime, OBJ_TREND, mWindow, mObvTime, 0, mObvTime, 0);
    ObjectSet("m.L"+mObvTime, OBJPROP_BACK, true);
    ObjectSet("m.L"+mObvTime, OBJPROP_STYLE, 0);
    ObjectSet("m.L"+mObvTime, OBJPROP_COLOR, mCol3);
    ObjectSet("m.L"+mObvTime, OBJPROP_WIDTH, mWidth);
    ObjectSet("m.L"+mObvTime, OBJPROP_RAY, false);

    ObjectCreate("m.Hnew"+mObvTime, OBJ_TREND, mWindow, mObvTime, 0, mObvTime, 0);
    ObjectSet("m.Hnew"+mObvTime, OBJPROP_BACK, true);
    ObjectSet("m.Hnew"+mObvTime, OBJPROP_STYLE, 0);
    ObjectSet("m.Hnew"+mObvTime, OBJPROP_COLOR, mCol4);
    ObjectSet("m.Hnew"+mObvTime, OBJPROP_WIDTH, mWidth);
    ObjectSet("m.Hnew"+mObvTime, OBJPROP_RAY, false);

    ObjectCreate("m.Lnew"+mObvTime, OBJ_TREND, mWindow, mObvTime, 0, mObvTime, 0);
    ObjectSet("m.Lnew"+mObvTime, OBJPROP_BACK, true);
    ObjectSet("m.Lnew"+mObvTime, OBJPROP_STYLE, 0);
    ObjectSet("m.Lnew"+mObvTime, OBJPROP_COLOR, mCol4);
    ObjectSet("m.Lnew"+mObvTime, OBJPROP_WIDTH, mWidth);
    ObjectSet("m.Lnew"+mObvTime, OBJPROP_RAY, false);
 
  return (0);
 }

//-----------------------------------------------------------------------------
bool CheckEarlyEZ(int t)
 {
  int mSeqUp = 0, mSeqDn = 0;

    for(int x = t - mMinFirstBars; x <= t; x++)
     {
      if(Close[x] > Open[x])
       mSeqUp ++;
      else
       mSeqUp = 0;
    
     if(Close[x] < Open[x])
       mSeqDn ++;
     else
       mSeqDn = 0;
   
     if(mSeqUp >= mBarsForCloseZone || mSeqDn >= mBarsForCloseZone) 
       {
         return(true);
       }
    }
    
   return (false);
 }
 
//-----------------------------------------------------------------------------

